/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.pci.model;

import java.util.ArrayList;
import java.util.List;

import javax.xml.namespace.QName;

import org.exoplatform.Constants;

/**
 * @author: Roman Pedchenko
 * @email:  roman.pedchenko@exoplatform.com.ua
 * @version: $Id$
 */

public class EventDefinition {
  private List description;
	private QName name;
  private List names;
  private QName alias;
  private List aliases;
  //private String xmlSchema;
  //private String jaxbMapping;
  private String javaClass;
  private String id;
  
	public List getDescription() {
    if(description == null) return Constants.EMPTY_LIST;
		return description;
	}
  
	public void setDescription(List description) {
		this.description = description;
	}
  
  public void addDescription(Description desc) {
  	if(this.description == null)  description = new ArrayList();
    this.description.add(desc);
  }
  
  public QName getPrefferedName() { return this.name; }

  public void setPrefferedName(QName value) {
    this.name = value;
    addName(value);
  }

  public void addName(QName value) {
    if (names == null)
      names = new ArrayList();
    names.add(value);
  }
  
  public List getNames() {
    if (names == null)
      return Constants.EMPTY_LIST;
    return names;
  }
  
  public QName getAlias() { return this.alias; }

  public void setAlias(QName value) {
    this.alias = value;
    addAlias(value);
  }

  public void addAlias(QName value) {
    if (aliases == null)
      aliases = new ArrayList();
    aliases.add(value);
  }
  
  public List getAliases() {
    if (aliases == null)
      return Constants.EMPTY_LIST;
    return aliases;
  }
  
  //public String getXmlSchema() { return this.xmlSchema; }

  //public void setXmlSchema(String value) { this.xmlSchema = value; }
  
  //public String getJaxbMapping() { return this.jaxbMapping; }

  //public void setJaxbMapping(String value) { this.jaxbMapping = value; }
  
  public String getJavaClass() { return this.javaClass; }

  public void setJavaClass(String value) { this.javaClass = value; }
  
  public String getId() { return this.id ; }

  public void setId(String value) { this.id = value ; }
}
